(************************************************************************************
Filename    :   Win32_RoomTiny_Main.cpp
Content     :   First-person view test application for Oculus Rift
Created     :   18th Dec 2014
Authors     :   Tom Heath
Copyright   :   Copyright 2012 Oculus, Inc. All Rights reserved.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*************************************************************************************)
/// This is the same sample as OculusRoomTiny(DX11),
/// but this time using the standard set of
/// utility functions provided in BasicVR.h - these functions we will be
/// used in subsequent samples.
unit UDemoUsingBasicVR;

interface

procedure Main;

implementation

uses
  UDirectXAppUtil, UBasicVR;

type
  TUsingBasicVR = class(TBasicVR)
  public
    constructor Create;
    procedure MainLoop; override;
  end;

{ TUsingBasicVR }

constructor TUsingBasicVR.Create;
begin
  inherited Create('Using BasicVR');
end;

procedure TUsingBasicVR.MainLoop;
var
  eye: NativeInt;
begin
  Layer[0] := TVRLayer.Create(Session);

  while HandleMessages do
  begin
    ActionFromInput;
    Layer[0].GetEyePoses;

    for eye := 0 to 1 do
    begin
      Layer[0].RenderSceneToEyeBuffer(MainCam, RoomScene, eye);
    end;

    Layer[0].PrepareLayerHeader;
    DistortAndPresent(1);
  end;
end;

procedure Main;
var
  app: TUsingBasicVR;
begin
  app := TUsingBasicVR.Create;
  try
    ExitCode := app.Run;
  finally
    app.Free;
  end;
end;

end.
